/***************************************************************************/
/*                                                                         */
/* FILE NAME : inp_gen.c                                                   */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

/*
  Randomly generate a set of binary string
*/

#include "ga.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern int preflip();
extern int evol, spop, nodecount;
extern double w[MAX_ND][MAX_ND];
extern int bstr[MAX_POP][MAX_ND];
extern long int fpseed;
extern double drand48(), calc_fitness();
extern FILE *fp;
extern float rgauss();
extern double my_calc_fitness();
extern double zs[MAX_POP];
extern double cost[MAX_POP];


float myRandom(low,high)
float low,high;
{ /*float frac = fmod(drand48() * lrand48(),(high-low)) ;
  return fabs(frac+low);
  */
  return(drand48()*(high-low)+low);
}

/*
* Randomly produces the graph.
*/
void generate_graph()
{
  int 		i,j;
  double u;


  /*printf("\nStep 1: Generate graph randomly");
  printf("\n\nPlease enter number of nodes (10-100):");
  scanf("%d",&nodecount);
  */


  for(i=0; i< nodecount; i++){
    w[i][i]=0;
    for(j=i; j < nodecount; j++){
      if (i!=j)
	/*
	if ( drand48() > 0.5 )
	  w[i][j]=(int)(10.0* drand48() -0.5)+1;
        */
	if ( myRandom(0.0,1.0) > 0.6 )
	  w[i][j]=(int)(10.0* myRandom(0.0,1.0) -0.5)+1;
	else 
	  w[i][j]=0;
      w[i][i] += w[i][j];
    }
    for(j=0; j< i; j++){
      w[i][j]=w[j][i];
      w[i][i] += w[i][j];
    }
  }

/*  for (i=0; i<nodecount; i++) {
    for (j=0; j<nodecount; j++)
      fprintf(fp, "%3.0f ", w[i][j]);
    fprintf(fp, "\n");  
  }  
*/
}/* end of generate_graph() */

/*
* Randomly produces the graph and writes the produced graph information
* to the given file.
*/
void generate_graph_write(FileName)
char *FileName;
{  FILE *FIn;
   int i,j;

   generate_graph();

   if((FIn=fopen(FileName,"w"))!=NULL)
   {  
      for(i=0;i<nodecount;i++)
      { fprintf(FIn,"\n");
	for(j=0;j<nodecount;j++)  fprintf(FIn,"%8.3f ",w[i][j]);
      }

      fclose(FIn);

   }
   else
     printf("\n %s could not be opened \n",FileName);

}/* end of generate_graph_write() */

double generate_sigma_graph(nodecount,sigma)
int nodecount;
double sigma;
{
   int i,j;
   long idum=-199939;
   double rn=0;

   printf("\n I am in generate_sigma_graph for %f random = %f",sigma,rn);
   for(i=0;i<nodecount;i++)
   {  w[i][i]=0;
     for(j=i;j<nodecount;j++)
     {   rn = (double) rgauss(&idum,0.0,(float)sigma); 
         w[i][j] = 1.0 + rn ; 
         w[i][i] +=w[i][j];
     }
   }

   for(j=0;j<i;j++)
   {  w[i][j]=w[j][i]; w[i][i] = w[j][j];}

   
   return rn;
}/* generate_sigma_graph() */

/*
* Randomly generates a solution for the initial phase.
*/
void generate_initial_set()
{
  int i, j, k, count0, count1, tempb;

  /*printf("\n spop = %d nodecount = %d ",spop,nodecount); */

/*
  printf("\n\nStep 2: Generate initial solutions");
  printf("\n\nPlease enter the size of population (10-1000):");
  scanf("%d", &spop);

  printf("\n\nStep 3: Start evolution");
  printf("\n\nHow many generations do you want to simulate?");
  scanf("%d", &evol);
*/

  for (i=0; i< MAX_POP; i++)
    for (j=0; j < MAX_ND; j++) bstr[i][j] = -1;

  for (i=0; i<spop; i++) 
    {
      count0 = count1 = 0;
      j = 0;
      while (j<nodecount) 
	{
	  /*if ((tempb = preflip(0.5)) ==0)*/ 
	  if ((tempb = (drand48()>0.5)) ==0) 
	    count0++;
	  else
	    count1++;
	  bstr[i][j] = tempb;
	  k = ++j;
	  if (count0== (nodecount/2)) 
	    for (j=k; j<nodecount; j++) bstr[i][j] = 1;
	  else if (count1== (nodecount/2) ) 
	    for (j=k; j<nodecount; j++) bstr[i][j] = 0;
	}
       zs[i] = calc_fitness(bstr[i]);
       cost[i] = my_calc_fitness(bstr[i]);
    }
}
